#ifndef AGENT_HPP
#define AGENT_HPP

#include "TreeNode.hpp"
#include "lua/lua.hpp"


class Agent : public TreeNode
{
public:
    typedef boost::shared_ptr<Agent> Ptr;
  class AgentException : public std::exception{
  public:
	AgentException(){}
        virtual const char* what() const throw(){ return "An unknown Agent script error was detected, killing the problematic Agent" ;}
  };
private:
    lua_State* m_lua;
    int m_luaRef;
    std::string m_brainFunctionName;
public:
    Agent(Vec2 pos, const char* brain); 
    Agent(const Agent& op);
    virtual void tick(double dT);
    virtual TreeNodeType is_type() const;
    std::string get_brain_function_name();
    
    
    
};

#endif // AGENT_HPP
