#include "BufferWindow.hpp"
#include "ui_BufferWindow.h"
#include <QFileDialog>
#include <QProcess>
#include <string>
#include <sstream>
BufferWindow::BufferWindow(QWidget* parent, QProcess* scLangProcess): QDialog(parent),ui(new Ui::BufferWindow),m_scLangProcess(scLangProcess),m_tableCount(0)
{
	ui->setupUi(this);

	connect(ui->m_importButton,SIGNAL(clicked()),this,SLOT(on_importTriggered()));
	connect(ui->m_reloadButton,SIGNAL(clicked()),this,SLOT(on_reloadTriggered()));
	QTableWidgetItem* t = new QTableWidgetItem("Buffer Index");
	ui->m_table->setVerticalHeaderItem(-1,t);


}

void BufferWindow::on_importTriggered()
{
  
  
  
  QString fileName = QFileDialog::getOpenFileName(this,
         tr("Import audio"), QDir::homePath(), tr("Audio Files (*.wav *.aiff )"));
  if(!fileName.isNull()){
    std::string file = fileName.toStdString();
    unsigned found = file.find_last_of("/\\");    
    std::string finalFile = file.substr(found+1);
    QTableWidgetItem* t = new QTableWidgetItem(QString::fromStdString(finalFile));
    QTableWidgetItem* t2 = new QTableWidgetItem(fileName);
    ui->m_table->setItem(m_tableCount,0,t);
    ui->m_table->setItem(m_tableCount,1,t2);

    m_tableCount+=1;
  
    
    std::stringstream ss;
    ss << "Buffer.read(s,\"" << fileName.toStdString() << "\",bufnum:"<< m_tableCount  <<    ");\n\x0c";  
    m_scLangProcess->write(ss.str().c_str());
    
  }
}


int BufferWindow::get_bufferTotal()
{
  return m_tableCount;
}


void BufferWindow::on_reloadTriggered()
{

}



