#include "FilledSurface.hpp"
#include "WorldEngine.hpp"
#include <opencv2/core/core_c.h>


FilledSurface::FilledSurface(RGBA baseColour)
{
  Vec2 worldsize = boost::get<Vec2>( WorldEngine::get_instance().get_world()->get_property("WorldSize").get_value());
  
  m_image = cvCreateImage(cvSize(worldsize.m_x,worldsize.m_y),IPL_DEPTH_8U,3);
  cvSet(m_image,cvScalar(baseColour.R(),baseColour.G(),baseColour.B()));
  
  set_image(m_image);
  
}



Surface::SurfaceType FilledSurface::is_type() const
{
  return ST_FILLED;
}
