#include "GridManager.hpp"
#include <stdexcept>


ScaleVector GridManager::m_grids = ScaleVector();

GridManager& GridManager::get_instance()
{
  static GridManager t;
  return t;
}




GridManager::GridManager()
{

}


void GridManager::add_scale(ScalePtr scale)
{
  if(scale){
    m_grids.push_back(scale);
  }else{
    throw "Scale is invalid";
  }
}


ScalePtr GridManager::get_scale(int index)
{
  try{
      return m_grids.at(index); 
  }catch(std::out_of_range& e){
      throw "Could not find scale with index provided";
  }
}

float GridManager::get_closest_value(int index, float value)
{
 try{
      return m_grids.at(index)->get_closest(value); 
  }catch(std::out_of_range& e){
      return value;
      //throw "Could not find scale with index provided";
  }
}
std::vector< ScalePtr >::iterator GridManager::begin()
{
  return m_grids.begin();
}
std::vector< ScalePtr >::iterator GridManager::end()
{
  return m_grids.end();
}


