#include "ImageManager.hpp"

ImageManager* ImageManager::s_instance =0;

ImageManager* ImageManager::get_instance()
{
  if(!s_instance)s_instance = new ImageManager();
  return s_instance;
}


ImageManager::ImageManager()
{

}

ImageManager::~ImageManager()
{
  if(s_instance)delete s_instance;
}

void ImageManager::render_image(TreeNode::Ptr node, QPainter& painter, QPointF& pos, float angle)
{
	    QPainterPath path;
	    int rad=5;
	    int type = int(  boost::get<float>( node->get_property("image").get_value()));
	    Vec2 size = boost::get<Vec2>(node->get_property("size").get_value());
	    painter.save();
	   // painter.rotate(angle);
	 
	    QPolygonF poly(3);
// 	    painter.translate(pos);
// 	    painter.rotate(angle);
// 	    poly.translate(pos);
	    float hx = size.m_x*0.5f;
	    float hy = size.m_y*0.5f;
	    /*
	    poly.push_back(QPointF(-hx,-hy));
	    poly.push_back(QPointF(-hx,hy));
	    poly.push_back(QPointF(hx,0));
	    
	    path.addPolygon(poly);
	    path.closeSubpath();
	    */
	    path.addEllipse(pos,rad,rad);
	    path.setFillRule(Qt::WindingFill);
	    QColor col(0,0,0,50);  
	    
	    switch(type){
	      case(0):
// 		path.addEllipse(pos,rad,rad);
// 		path.setFillRule(Qt::WindingFill);
		col = QColor(0,0,0,50);
		break;
	      case(1):
		col = QColor(255,0,0,50);	
		break;
	      case(2):
		col = QColor(0,255,0,50);	
		break;
	      case(3):
		col = QColor(0,0,255,50);	
		break;
	      case(4):
		col = QColor(255,255,0,50);	
		break;
	      case(5):
		col = QColor(0,0,255,50);
		break;
	      case(6):
		col = QColor(0,255,255,50);	
		break;
	    };
	    if(node->is_selected()){
	      col = QColor(255,125,125,125);
	      painter.drawRoundedRect( pos.rx() - hx,pos.ry() - hy,size.m_x,size.m_y,2,2);
	      path.addEllipse(pos,rad,rad);
	    }
	    painter.fillPath(path,QBrush(col));	

	    painter.restore();
}

