#include "LinearMotionModel.hpp"
#include "TreeNode.hpp"
#include "WorldEngine.hpp"
#include <iostream>
LinearMotionModel::LinearMotionModel(TreeNode* parent): 
  MotionModel(parent)
{
// DebugStream << "Created liner motion model"<<std::endl;
}



MotionModel::MotionType LinearMotionModel::is_type() const
{
  return MT_LINEAR;
}
void LinearMotionModel::tick(double Dt)
{
    //need to obtain current speed from properties
  Vec2 vel =   boost::get<Vec2 >( get_parent()->get_property("Velocity").get_value() );
  Vec2 wSize = boost::get<Vec2>(WorldEngine::get_instance().get_world()->get_property("WorldSize").get_value());
  Vec2 pos = boost::get<Vec2>(get_parent()->get_property("pos").get_value()   )  + vel*Dt;
  if(pos.m_x < 0)pos.m_x = 0;
  if(pos.m_y < 0)pos.m_y = 0;
  if(pos.m_x > wSize.m_x)pos.m_x = wSize.m_x;
  if(pos.m_y > wSize.m_y)pos.m_y = wSize.m_y;
  get_parent()->set_property("pos",pos);
  
  
}
void LinearMotionModel::compute_grid_attraction(double Dt)
{

}
