#ifndef MOTIONMODEL_HPP
#define MOTIONMODEL_HPP

#include <boost/variant.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/weak_ptr.hpp>
#include <map>
#include "Vec2.hpp"






class TreeNode;

class MotionModel
{ 
public:
	enum MotionType {
	    MT_STATIC = 0,
	    MT_LINEAR,
	    MT_PHYSICS,
	    MT_PATH
	};
	  typedef boost::shared_ptr<MotionModel> Ptr;
private:
  TreeNode* m_parent;

protected:
  MotionModel(TreeNode* parent);
public:  
  static MotionModel::Ptr factory(MotionModel::MotionType type, TreeNode* parent);
  virtual void tick(double Dt)=0;
  virtual void compute_grid_attraction(double Dt) = 0;
  
  virtual MotionType is_type()const= 0; 
  TreeNode* get_parent() const;
  
  
  
  
};

#endif // MOTIONMODEL_HPP
