#include "PathMotionModel.hpp"
#include <iostream>
#include <lo/lo_osc_types.h>
#include "PathManager.hpp"
#include "TreeNode.hpp"
#include "WorldEngine.hpp"

void PathMotionModel::compute_grid_attraction(double Dt)
{
  
}
MotionModel::MotionType PathMotionModel::is_type() const
{
  return MT_PATH;
}



PathMotionModel::PathMotionModel(TreeNode* parent): MotionModel(parent)
{
  DebugStream << "Path motion model spawned"<<std::endl;
  parent->set_property("Thrust",Vec2(10,10));
  
}


void PathMotionModel::tick(double Dt)
{
  
  
  
  int pathIndex;// =  int( boost::get<int>( get_parent()->get_property("path").get_value()));
  int segment;// = boost::get<int>(get_parent()->get_property("segment").get_value());
  
  float speed =  boost::get<float>( get_parent()->get_property("pspeed").get_value());
  
  try {
    pathIndex =   boost::get<int>( get_parent()->get_property("path").get_value());
   
  }catch(boost::bad_get& e){
    pathIndex =  int( boost::get<float>( get_parent()->get_property("path").get_value()));
   
  }
  if(PathManager::get_instance().get_path(pathIndex)->empty()){
      return; 
  }
  
  
  try{
     segment = boost::get<int>(get_parent()->get_property("segment").get_value());
    
  }catch(boost::bad_get& e){
     segment = int(	  boost::get<float>(get_parent()->get_property("segment").get_value()));
  }
  PathPtr activePath = PathManager::get_instance().get_path(pathIndex);
  if( activePath.get() == NULL) return;
  if( activePath->size() < 2 ){
   return; 
  };
  
  
  float segPos = boost::get<float>(get_parent()->get_property("segpos").get_value());
  float rPos = segPos;
//   DebugStream << "segPos "<<segPos << " rpos "<<rPos << " segment "<< segment<<std::endl; 
  PointData data = activePath->lin_interp(segment,rPos);
//   DebugStream << "interp p "<< data.pos<<std::endl;
  rPos += (Dt * speed);
  int seg = data.segment;
  if(rPos >1.0f){
	double fract,inte;
	fract = modf(rPos,&inte);
// 	DebugStream << "fract "<< fract<<std::endl;
	rPos = fract;	
	seg +=1;
  }
  
  get_parent()->set_property("segpos",rPos);
  get_parent()->set_property("segment",seg);
  
  int pathLock;
  try{
    pathLock = boost::get<int>( get_parent()->get_property("pathLock").get_value());
  }catch(boost::bad_get& e){
     pathLock = int( boost::get<float>( get_parent()->get_property("pathLock").get_value()));
  }
  
  if(pathLock == 0){
    //   DebugStream << "segPos "<<segPos << " rpos "<<rPos << " segment "<< segment<<std::endl; 
      Vec2 current = get_parent()->get_pos();
      Vec2 targetPos = data.pos;
      Vec2 thrust = boost::get<Vec2>( get_parent()->get_property("Thrust").get_value());
      Vec2 delta = (targetPos - current) * thrust;

	
      Vec2 vel =  delta;
      Vec2 wSize = boost::get<Vec2>(WorldEngine::get_instance().get_world()->get_property("WorldSize").get_value());
      Vec2 pos = boost::get<Vec2>(get_parent()->get_property("pos").get_value()   )  + vel*Dt;
      if(pos.m_x < 0)pos.m_x = 0;
      if(pos.m_y < 0)pos.m_y = 0;
      if(pos.m_x > wSize.m_x)pos.m_x = wSize.m_x;
      if(pos.m_y > wSize.m_y)pos.m_y = wSize.m_y;
      
      
      
      get_parent()->set_property("pos",pos);
      
  }else{
      get_parent()->set_property("pos",data.pos);
  }
//   get_parent()->set_property("Velocity",vel);
}

