#include "PhysicsMotionModel.hpp"
#include "WorldEngine.hpp"
#include <iostream>

PhysicsMotionModel::PhysicsMotionModel(TreeNode* parent): MotionModel(parent)
{
// DebugStream << "Created physics motion model"<<std::endl;
}


MotionModel::MotionType PhysicsMotionModel::is_type() const
{
  return MT_PHYSICS;
}

void PhysicsMotionModel::tick(double Dt)
{
    Vec2 F = boost::get<Vec2 >(WorldEngine::get_instance().get_world()->get_property("Gravity").get_value() );
    F += boost::get<Vec2 >(get_parent()->get_property("Thrust").get_value() );
    float mass = boost::get<float>(get_parent()->get_property("Mass").get_value());
    Vec2 vel =  boost::get<Vec2>(get_parent()->get_property("Velocity").get_value())    ;
    float damping =  boost::get<float>(get_parent()->get_property("Damping").get_value())    ;
    if(mass <= 0)mass = 0.001;
    Vec2 a = F/mass;
    vel += a*Dt;
    vel *= damping;
    Vec2 wSize = boost::get<Vec2>(WorldEngine::get_instance().get_world()->get_property("WorldSize").get_value());
    Vec2 pos = boost::get<Vec2>(get_parent()->get_property("pos").get_value()   ) + vel*Dt;
    float loss = - boost::get<float >(WorldEngine::get_instance().get_world()->get_property("EnergyLoss").get_value() );
    if(pos.m_x < 0){ pos.m_x = 0; vel.m_x *= loss  ; }
    if(pos.m_y < 0){ pos.m_y = 0; vel.m_y *= loss ;  }
    if(pos.m_x > wSize.m_x){pos.m_x = wSize.m_x; vel.m_x *= loss;   }
    if(pos.m_y > wSize.m_y){pos.m_y = wSize.m_y; vel.m_y *= loss;   }
    get_parent()->set_property("pos",pos);
    get_parent()->set_property("Velocity",PropertyValue(vel));
    
}

void PhysicsMotionModel::compute_grid_attraction(double Dt)
{

}
