#include "PropertyDelegate.hpp"
#include <QLineEdit>
#include <iostream>
#include "PropertyModel.hpp"
#include "Utilities.hpp"



PropertyDelegate::PropertyDelegate(QObject* parent): QItemDelegate(parent)
{
DebugStream << "Spawning property delegate"<<std::endl; 
}

QWidget* PropertyDelegate::createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
   DebugStream << "Creating property editor"<<std::endl;
      if(index.column() == 1){
	    QLineEdit* editor(new QLineEdit(parent)); 
	    DebugStream << "Creating property editor 1"<<std::endl;
	    //editor->setMaximumSize(option.rect.size());
   
	    return editor;
      }else{
	  return QItemDelegate::createEditor(parent,option,index);
      }
}
void PropertyDelegate::setEditorData(QWidget* editor, const QModelIndex& index) const
{
      if(index.column() == 1){

	QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
	lineEdit->setText(  index.data().toString()        );  
      }else{
	QItemDelegate::setEditorData(editor, index);
      }
}
void PropertyDelegate::setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const
{
        if(index.column() == 1){
//     QItemDelegate::setModelData(editor, model, index);
      QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
      PropertyModel* propertyModel = static_cast<PropertyModel*>(model);
	    model->setData(index,lineEdit->text());
	}else{
	    QItemDelegate::setModelData(editor,model,index);
	}
}
