#ifndef PROPERTYHEADER_HPP
#define PROPERTYHEADER_HPP

#include <QHeaderView>
#include "Vec2.hpp"

class Property;
class MainWindow;

class PropertyHeader : public QHeaderView
{
  Q_OBJECT
  int m_currentSelectionIndex;
  MainWindow* m_mainWindow;
  Property* m_currentProperty;  
  int m_dragRange;
  Vec2 m_mouseClickPos;
  enum MouseMode{
    PMM_NORMAL = 0,
    PMM_CLICKED,
    PMM_DRAGGING
  }m_mouseMode;
  
public:
    PropertyHeader(Qt::Orientation orientation, QWidget* parent,MainWindow* window );
    void mousePressEvent(QMouseEvent* e);
    void mouseMoveEvent(QMouseEvent* e);
    void mouseReleaseEvent(QMouseEvent* e);
 
};

#endif // PROPERTYHEADER_HPP
