#ifndef PROPERTYMODEL_HPP
#define PROPERTYMODEL_HPP

#include <QAbstractTableModel>
#include "TreeNode.hpp"
class PropertyModel : public QAbstractTableModel
{
  Q_OBJECT
  int m_nodeId;
  TreeNode::WPtr m_node;
  public:
    PropertyModel(QObject* parent, int nodeId);
    virtual int rowCount(const QModelIndex& parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex& parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
    virtual Qt::ItemFlags flags(const QModelIndex& index) const;
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
    virtual bool setData(const QModelIndex& index, const QVariant& value, int role = Qt::EditRole);
    void update();
};

#endif // PROPERTYMODEL_HPP
