#include "StaticSurface.hpp"
#include <iostream>
#include <opencv2/opencv.hpp>
#include "Utilities.hpp"
// #include <highgui.h>

StaticSurface::StaticSurface(std::string filepath): m_path(filepath)
{
  DebugStream << "Attemtpgint to load static surface with path\n"<<filepath<<std::endl;
  try{
    set_image( cvLoadImage(filepath.c_str())  );
  }catch(...){
      throw "Could not load image";
  }
}

Surface::SurfaceType StaticSurface::is_type() const
{
    return ST_STATIC;
}

const std::string& StaticSurface::get_path() const
{
  return m_path;
}
