#ifndef TREENODEMODEL_HPP
#define TREENODEMODEL_HPP

#include <QTreeView>



class TreeNodeModel : public QAbstractItemModel
{
  Q_OBJECT
  
  public:

    TreeNodeModel(QObject* parent);
    virtual QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
    virtual QModelIndex parent(const QModelIndex& child) const;
    virtual int rowCount(const QModelIndex& parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex& parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
    void update();
    void refresh(int agentID);
};

#endif // TREENODEMODEL_HPP
