#ifndef __UTILITIES__
#define __UTILITIES__



#include <cstring>

#include <iostream>
#include <fstream>


#ifdef DEBUG
  #define dbgStream std::cerr
  #define DEBUG_ONLY(x) x
#else
  #define dbgStream g_debugLog
  #define DEBUG_ONLY(x) 
#endif


#if _WIN32
#define DEBUG_OUTPUT(x) OutputDebugString(x); 
//#define DEBUG_OUTPUT(x) std::cerr << x;
#else
#define DEBUG_OUTPUT(x) std::cerr << x;
#endif

#if DEBUG
#define DebugOut(fmt, ...) \
    char buf[256]; \
    sprintf(buf, fmt, __VA_ARGS__ ) ; \
    DEBUG_OUTPUT(buf)
    
#else
#define DebugOut(fmt, ...)
  
#endif



class DebugStreamBuf : public std::streambuf
{
  static const int SIZE=8;
  char m_buf[SIZE];
  std::ofstream m_file;
private:
  void doflush(){
      std::ptrdiff_t n = pptr() - pbase();
      pbump(-n);
      //fsom::DebugStream << "|";
      #if DEBUG
      std::cerr.write(pbase(), n);
      m_file.write(pbase(), n);
      #endif
     // OutputDebugString()
  }
protected:
  virtual int overflow(int ch)
  {
    if( ch != traits_type::eof() )
    {
      *pptr() = ch;
      pbump(1);
      doflush();
      return ch;
    }
    return traits_type::eof();
  }
  virtual int sync(){
    doflush();
    return 0;
    
  }
public:
    DebugStreamBuf() :
      m_file("log.txt")
    {
      setp(m_buf, m_buf+SIZE-1);
    }
  
};
static DebugStreamBuf debugBuf;
static std::ostream DebugStream(&debugBuf);







#endif
