#include "VideoSurface.hpp"
#include <iostream>
// #include <cv.h>
#include <opencv2/opencv.hpp>
// #include <highgui.h>
#include "Utilities.hpp"

Surface::SurfaceType VideoSurface::is_type() const
{
    return ST_VIDEO;
}
VideoSurface::VideoSurface(const std::string& filepath): m_filePath(filepath)
{

    DebugStream << "Attempting to load static video with path\n"<<filepath<<std::endl;
    try{
    m_capture =  cvCreateFileCapture(filepath.c_str());
    if(!m_capture)throw "could not load video";
    }catch(...){
      throw "could not load video";
    }
    
}

void VideoSurface::tick(float dt)
{
  IplImage* frame = cvQueryFrame(m_capture);
  if(!frame)return;
  set_image(frame);
}
