#include "WorldAgent.hpp"

WorldAgent::WorldAgent(Vec2 pos):
  TreeNode(pos)
{
  set_motion_model(MotionModel::MT_LINEAR);
  add_property("Image",Property(std::string("")));
  set_property("Title",std::string("WorldNode"));
  add_property("Gravity",Property(Vec2(0,0)));
  add_property("WorldSize",Property(Vec2(100,100)));
  add_property("EnergyLoss",Property(0.75f));
//   set_property("size",Property(Vec2(100,100)));
  set_active_state(true);
}

WorldAgent::~WorldAgent()
{

}

void WorldAgent::add_image_path(std::string& path)
{
  set_property("Image",path);
}
std::string WorldAgent::get_image_path() const
{
  //should assert it is the right type in future....
  std::string t("Image");
  return  boost::get<std::string>(get_property(t).get_value()); 
}
TreeNode::TreeNodeType WorldAgent::is_type() const
{
  return TN_WORLD;
}
