
function ai_LifeExample()
  initai()
  local worldsize = getWorldSize()
  local life = 10
  addP("bufNum",1)
  addP("amp",0.2)
  addP("speed",getP("pos"):y()/ worldsize:y()*2)
  addP("startpos", getP("pos"):x()/ worldsize:x() )
  addP("pan",0)
  setP("dur",1)
  setP("image",1)
  changeMotionModel("Physics")
  setP("SynthDef","bubble")
  while life > 0 do
    life = life -1
    if getMeanCol(0) > 150 then  
      local target = find_highest_mean(getP("pos"),10)
      local childid = spawn(0,1,"ai_LifeExample",target:x(), target:y())
      life =  0
      coroutine.yield()
    end
    pause(1)
    coroutine.yield()
  end
  die()
end



function ai_RandomIntensitySpawner()
  initai()
  addP("randomVecRate",0.5)
  addP("randomXThresh",60)
  addP("randomYThresh",60)
  addP("threshold",100)
  local randX = math.random()* getP("randomXThresh")
  local randY = math.random()* getP("randomXThresh")
  setP("Velocity",Vec2.new(randX,randY))
  addP("grainsize",1)
  local counter = 0
  while true do
    if counter > getP("randomVecRate") then
      print("triggered")
      local xt = getP("randomXThresh")
      local yt = getP("randomYThresh")
      local randX = math.random()* xt - (xt*0.5) 
      local randY = math.random()* yt - (yt*0.5)
      killChildren()
      setP("Velocity",Vec2.new(randX,randY))
      counter = 0
    end
    
    if getMeanCol(0) > getP("threshold") then
       local id = getID()
       local childid = spawnRelative(id,1,"ai_BasicBubble",0,0 )
       setPID("dur",getP("grainsize"),childid)
       setPID("SynthDef","metamu",childid)
    end
    
    pause(0.001)
    counter = counter + 0.01
  end
  die()
end


function ai_RandomIntensitySpawnerINVERT()
  initai()
  addP("randomVecRate",0.5)
  addP("randomXThresh",60)
  addP("randomYThresh",60)
  addP("threshold",150)
  local randX = math.random()* getP("randomXThresh")
  local randY = math.random()* getP("randomXThresh")
  setP("Velocity",Vec2.new(randX,randY))
  addP("grainsize",1)
  local counter = 0
  while true do
    if counter > getP("randomVecRate") then
      print("triggered")
      local xt = getP("randomXThresh")
      local yt = getP("randomYThresh")
      local randX = math.random()* xt - (xt*0.5) 
      local randY = math.random()* yt - (yt*0.5)
      killChildren()
      setP("Velocity",Vec2.new(randX,randY))
      counter = 0
    end
    
    if getMeanCol(0) < getP("threshold") then
       local id = getID()
       local childid = spawnRelative(id,1,"ai_BasicBubble",0,0 )
       setPID("dur",getP("grainsize"),childid)
    end
    
    pause(0.001)
    counter = counter + 0.01
  end
  die()
end


function ai_AttractIntensitySpawner()
   initai()
   addP("threshold",150)
   addP("colthreshold",10)
   addP("grainsize",1)
   setP("image",2)
   while true do
    local pos =  getP("pos")
    setP("pos", find_highest_mean(pos, getP("colthreshold")) )
    if getMeanCol(0) > getP("threshold")then
       local id = getID()
       local childid = spawnRelative(id,1,"ai_BasicBubble",0,0 )
       setPID("dur",getP("grainsize"),childid)
       setPID("SynthDef","metamu",childid)

    end
    
    coroutine.yield()  
  end
end

function ai_ColourTester()
  initai()
  while true do
--    print ( getR(0))
--    print ( getG(0))
--    print ( getB(0))
    print(getTotalCol(0))
    print(getMeanCol(0))
    coroutine.yield()
  end
  die()
end


function ai_ImgWalker()
  initai()
  changeMotionModel("Physics")
  addP("dur",10)
  setP("Velocity",Vec2.new(50,0))
  addP("r",0)
  addP("g",0)
  setP("SynthDef","metamu")
  local i =0
  while i < getP("dur") do
    local pos = getP("pos");
    setP("r" , getRedFromPoint(0,pos) )     
    setP("g" , getGreenFromPoint(0,pos) )
    i = i + getDT()
    coroutine.yield()
  end
  die()
end



function ai_StaticImgWalker()
  initai()
  changeMotionModel("Physics")
  addP("dur",10)
  setP("Velocity",Vec2.new(0,0))
  addP("r",0)
  addP("g",0)
  setP("SynthDef","metamu")
  local i =0
  while i < getP("dur") do
    local pos = getP("pos");
    setP("r" , getRedFromPoint(0,pos) )     
    setP("g" , getGreenFromPoint(0,pos) )
    i = i + getDT()
    coroutine.yield()
  end
  die()
end

function ai_InvertedImgWalker()
  initai()
  changeMotionModel("Physics")
  addP("dur",10)
  setP("Velocity",Vec2.new(100,0))
  addP("r",0)
  addP("g",0)
  setP("SynthDef","metamu")
  local i =0
  while i < getP("dur") do
    local pos = getP("pos");
    setP("r" , threshold(   255 - getRedFromPoint(0,pos),150   ) )     
    setP("g" , threshold(  255 - getGreenFromPoint(0,pos),150 ))
    i = i + getDT()
    coroutine.yield()
  end
  die()
end


function ai_InvertedStaticImgWalker()
  initai()
  changeMotionModel("Physics")
  setP("Velocity",Vec2.new(0,0))
  addP("r",0)
  addP("g",0)
  setP("SynthDef","metamu")
  local i =0
  while true do
    local pos = getP("pos");
    setP("r" , threshold(   255 - getRedFromPoint(0,pos),150   ) )     
    setP("g" , threshold(  255 - getGreenFromPoint(0,pos),150 ))
    i = i + getDT()
    coroutine.yield()
  end
  die()
end

function ai_metachanger()
  initai()
  addP("rate",1)
  pause(0.5)
  while true do
  local id = getID()
  local pos = getP("pos")
  spawnRelative(id,1,"ai_MetaBar",0,0 )
  pause(getPID("rate",id))
  end
end

function ai_MetaBar()
  initai()
  local pos = getP("pos")
  addP("cVelocity",Vec2.new(60,0))
  local id = getID()
  for i = 0,25,1 do
    local v = pos + Vec2.new(0,i*10)
    local childid = spawnRelative(0,1,"ai_ImgWalker",v:x(),v:y()  )
    setPID("Velocity",getPID("cVelocity",id),childid)
  end
  coroutine.yield()
  die()
end

function ai_StaticMetaBar()
  initai()
  local pos = getP("pos")
  local id = getID()
  for i = 0,25,1 do
    local v = pos + Vec2.new(0,i*10)
    local childid = spawnRelative(0,1,"ai_StaticImgWalker",v:x(),v:y()  )
  end
  coroutine.yield()
  die()
end

function ai_InvertedMetaBar()
  initai()
  local pos = getP("pos")
  addP("cVelocity",Vec2.new(60,0))
  local id = getID()
  for i = 0,25,1 do
    local v = pos + Vec2.new(0,i*10)
    local childid = spawnRelative(0,1,"ai_InvertedImgWalker",v:x(),v:y()  )
    setPID("Velocity",getPID("cVelocity",id),childid)
  end
  coroutine.yield()
  die()
end

function ai_InvertedStaticMetaBar()
  initai()
  local pos = getP("pos")
  local id = getID()
  for i = 0,25,1 do
    local v = pos + Vec2.new(0,i*10)
    local childid = spawnRelative(0,1,"ai_InvertedStaticImgWalker",v:x(),v:y()  )
  end
  coroutine.yield()
  die()
end


function ai_Reader()
  initai()
  changeMotionModel("Physics")
  setP("Velocity",Vec2.new(100,0))
  while true do
    local pos =  getP("pos")
    if getRedFromPoint(0,pos) > 200 then
    spawnRelative(getID(),1,"ai_Follower",0,0)  
   -- pause(1)
    end
    coroutine.yield()  
  end
end


function ai_Reader2()
  initai()
  changeMotionModel("Physics")
  setP("Velocity",Vec2.new(100,0))
  while true do
    local pos =  getP("pos")
    if getRedFromPoint(0,pos- Vec2.new(0,5)) > 200 then
    setP("Velocity",Vec2.new(0,-100))  
   -- pause(1)
    end
    coroutine.yield()  
  end
end

function find_red_max( pos, thres )
  local ret = pos
  local max = thres
  for n = 0, 10, 1 do
    local a = (2 * math.pi / 10) * n
    local v = pos - Vec2.new(math.cos(a)*5,math.sin(a)*5)
    local mag = getRedFromPoint(0,v)
    if mag > max then
      max = mag
      ret = v
    end
  end
  return ret
end

function find_highest_mean( pos, thres )
  local ret = pos
  local max = thres
  for n = 0, 10, 1 do
    local a = (2 * math.pi / 10) * n
    local v = pos - Vec2.new(math.cos(a)*5,math.sin(a)*5)
    local mag = getMeanFromPoint(0,v)
    if mag > max then
      max = mag
      ret = v
    end
  end
  return ret
end



function ai_Reader3()
  initai()
  changeMotionModel("Static")
  setP("Velocity",Vec2.new(0,0))
  
  setP("SynthDef","test")
  while true do
    local pos =  getP("pos")
    setP("pos", find_red_max(pos, 155) )  
    coroutine.yield()  
  end
end









