--Here you will find a collection of Agents that spawn children
--This is dependent on ExamplePlayers being loaded.

function ai_SpawnBasic()
	initai()
	addP("childCount",10)
	addP("childSeparation",2)
	addP("childType","ai_BasicPlayer")
	local id = getID()
	print(id)
	for i = 0, getPID("childCount",id),1 do
		spawnRelative(id,1,getPID("childType",id),0,0)
		pause(getPID("childSeparation",id))
	end
	pause(getPID("childSeparation",id))
	die()
end



function exponentialSpawn(overalltime,numspawns,ratio,parentid,type)
--	print(overalltime)
	local previous = 0
	for i =0,numspawns,1 do
		spawnRelative(parentid,1,type,math.random(-20,20),math.random(-20,20))
		--print("spawned") 
		local absT = (math.pow(i/numspawns,ratio)*overalltime )
		local deltaT = absT -   previous
		previous = absT
--		print (deltaT, " ",absT )
		pause( deltaT )
	end
end


function ai_ExpoSpawn()
	initai()
	local dur = 10
	addP("dur",4)
	addP("numLoops",10)
	addP("childType","ai_BasicPlayer")
	addP("ratio",0.2)
	addP("numspawns",10)
	local id = getID()
	for i = 0, getPID("numLoops",id), 1 do
		local time = getPID("dur",id)
		local spawns = getPID("numspawns",id)
		local ratio = getPID("ratio",id)
		local ctype = getPID("childType",id) 
		exponentialSpawn(time,spawns,ratio,id,ctype)
		pause(getPID("dur",id))
	end
	pause(10)
	die()
end



function ai_AbstractSpawn()
	initai()
	addP("childType","ai_BasicPlayer")
	addP("spawn",0)
	addP("spawnPos",Vec2.new(100,100))
	local id = getID()
	while true do 
		if getPID("spawn",id) > 0 then
			spawn(id,1,getPID("childType",id),getPID("spawnPos",id))
			setPID("spawn",0,id)
		end
		coroutine.yield()
	end
	die()
end



--ai_PosPlayer
function ai_StackSpawn()
	initai()
	addP("dur",20)
	addP("childTotal",10)
	addP("stackdistribution",4)
	addP("childType","ai_PosPlayer")
	addP("stackheight",400)
	local id = getID()
	while true do 
		local args = {dur = getPID("dur",id)}
		local total =getPID("childTotal",id) 
		local height = getPID("stackheight",id)
		for i = 0, total ,1 do
			local ratio = getPID("stackdistribution",id)
			local child  = spawnRelativeP(args,id,1,getPID("childType",id), 0,math.pow(i/total,ratio) *height )
			coroutine.yield()
			coroutine.yield()
			setPID("dur",getPID("dur",id),child)		
		end
		pause(getPID("dur",id))
	end
	die()
end


function ai_EndlessStacks()
	initai()
	addP("xdistribution",50)
	addP("ydistribution",50)
	addP("childType","ai_StackSpawn")
	addP("randomTime",5)
	local id = getID()
	while true do
		local pos = getPID("pos",id)
		local xdist = getPID("xdistribution",id)
		local ydist = getPID("ydistribution",id)
		spawnRelative(id,1,getPID("childType",id), math.random(xdist * -1.0 , xdist ), math.random(ydist * -1.0 , ydist ) )

		pause(math.random(0,getPID("randomTime",id)))
	end
	die()
end

















--This is a template for live coding.....
function ai_LiveSpawn()
	initai()
	local id = getID()
	local run = true;
	local count = 0
	while run do 
		run = live_code(id,count)
		count = count +1
		pause(0.25)
	end
	die()
end

--a placeholder for some live coding
function live_code2(parentid,count)
 --	print (count)
 	local args = {bufNum = count % 4}
 	if count % 2 == 0 then
 		spawnP({bufNum = 2 },parentid,1,"ai_BasicPlayer",100,100)
 	end
 	if count % 4 == 0 then
 		spawnP({bufNum = 1 },parentid,1,"ai_BasicPlayer",100,100)
 	end


 	return true
end


--This is a template for live coding.....
function ai_LiveSpawn2()
	initai()
	local id = getID()
	local count = 0
	while true do 
		local p = live_code2(id,count)
		count = count +1
		if p <= 0 then break end
		pause(p)
	end
	die()
end

function live_code2(parentid,count)
 	--print (count)
 	local i = count % 6
 	if count % 4  == 0 then 
 		spawnP({bufNum = 1,dur = 0.1},parentid,1,"ai_BasicPlayer",100,100)
 	end
	if (count % 2 )  == 0 then 
 		spawnP({bufNum = 0,dur = 0.1},parentid,1,"ai_RPosPlayer",math.random(100,1000),0)
 	end
	if (count % 1 )  == 0 then 
 		spawnP({bufNum = 3,amp = 0.8,dur = 0.1,rate = (count%10)*0.2},parentid,1,"ai_BasicPlayer",0,0)
 	end
 	return 0
end
