function pause(delayTime)
	--print ("pausing",delayTime)
	
	local t = 0
	while t < delayTime do
		coroutine.yield()
		t = t + getDT()
		--print("pause continues ",t,delayTime)
	end
end

function detectsurface(id,pos,aitype,range)
  local worldsize = getWorldSize()
  if pos:x() <= 0+range then spawnRelative(id,1,aitype,0,0) return 1	end
  if pos:y() <= 0+range then spawnRelative(id,1,aitype,0,0) return 1	end
  if pos:x() >= worldsize:x()-range then spawnRelative(id,1,aitype,0,0) return 1 end
  if pos:y() >= worldsize:y()-range then spawnRelative(id,1,aitype,0,0)	return 1 end
  return 0
end

function wait()
	coroutine.yield()
end

function  yield()
	coroutine.yield()	
end

function waitforchild()
	coroutine.yield()
	coroutine.yield()
end

function threshold(value,thresh)
  if value > thresh then return value end
  return 0
end

function printtable(table)
   for key,value in pairs(table) do print(key,value)end
   print (stuff)
end


function ai_Emptygrain()
  initai()
  pause(0.1)
  die()
end

function ai_MoveTester()
  initai()
  move(10,0)
  move(Vec2.new(0,10))
  pause(1)
  die()
end

function ai_PathTester()
  initai()
  changeMotionModel("Path")
  pause(120)
  die()
end

function ai_BasicPlayer()
  initai()
  local worldsize = getWorldSize()
  local args = { bufNum = 0,amp = 1,speed = getP("pos"):y()/ worldsize:y()*5 ,pan = 0,dur=3,image = 0  }  
  addP(args) 
  setP("SynthDef","grain")
  changeMotionModel("Physics")
    for i = 0 , getP("dur")*1000,1 do
	setP("speed",getP("pos"):y()/worldsize:y()*5 )
	pause(0.001)
    end
    die()
end  

function ai_HarmonicPlayer()
    initai()
    local pos = getP("pos")
    print(pos)
    for i = 0, 5,1 do
      local childY = (0.5*i) * pos:y()   
      local cPos = Vec2.new(pos:x(),childY )
      local args = {test = 1}
      spawn(args,getID(),1,"ai_BasicPlayer",cPos)
    end
    pause(10)
    die()
end


function ai_Cluster()
  initai()
  local args = {spawnXrange = 10,spawnYrange = 10,numChildren =math.random(0,10),rate = math.random(0.01,10),grainsize = math.random(0.001,2)} 
  addP(args)
  local id = getID()
  while true do
    for i = 0,getP("numChildren"),1 do
     local xrange = getPID("spawnXrange",id)
     local yrange = getPID("spawnYrange",id)
     local childid = spawnRelative(id,1,"ai_BasicPlayer",(math.random()* xrange) - xrange*0.5, (math.random()* yrange) - yrange*0.5 )
     setPID("dur", getPID("grainsize",id),childid)
    end  
    pause(getPID("rate",id))
  end
  die()
end

function ai_GravityChanger()
  initai()
  addP("rate",math.random(1,10))
  while true do
    setPID("Gravity",Vec2.new( math.random(-2.5,2.5),math.random(-2.5,2.5) ) ,0  )
    pause(getP("rate"))
  end
end

function ai_Bouncer()
  initai()
  changeMotionModel("Physics")
  local args = {NoOfBounces = 5,Spawntype = "ai_BasicPlayer",Velocity = Vec2.new(100,100)}
  addP(args)
  local i = 0
  while i < getP("NoOfBounces") do
    local t = detectsurface(getID(),getP("pos"),getP("Spawntype"),0)
    i = i + t 
    coroutine.yield()
  end
  pause(5)
  die()
end

function ai_Follower()
  initai()
  changeMotionModel("Physics")
  --TODO update the synth
  local args = {Mass = math.random(0.01,0.6),amp = 0.1,SynthDef = "test"}
  --setP("SynthDef","test")
  while true do
    print("follower running")
    local mypos = getP("pos")
    drawRelative(0,Vec2.new(0,0),255,0,0  )
    print("follower drawn" )
    local targetId = getNearest(mypos)
    local targetPos = getPID("pos",targetId)
    local dir = (targetPos - mypos):norm()
    setP("Thrust",dir*2 )
    coroutine.yield()
  end

end

function ai_Circle()
  initai()
  changeMotionModel("Physics")
  for n = 0, 10000,1 do
    setP("Mass",0.001)
    setP("Velocity", Vec2.new(math.sin(n)  *( n* 10 ),math.cos(n )* (n*10) ))
     -- drawRelative(0,Vec2.new(0,0),255,0,0)
      drawCircle(0,getP("pos"),3,RGBA.new(255,0,0,100),-1)
      pause(0.1)
  end
  die()
end


function ai_Spirals()
   initai()
   while true do 
     spawnRelative(getID(),1,"ai_Circle",Vec2.new(0,0))
     pause(0.5) 
   end
end


function ai_TGrain()
  initai()
  local args = {channels = 2,triggerRate = 1,bufnum = 0,rate = 1, centrePos =0,gsize = 0.25,pan = 0, amp = 0.2,interp = 4,bits = 23,maxDel = 4,delay = 0.1,decay = 0.5,dry = 0.5,wet = 0.5,tType = 0,SynthDef = "grains"}  
  addP(args)
  while true do 
    coroutine.yield()
  end
  die()
end