
function ai_Adder()
	initai()
	addP("aAmp",1)
	addP("bAmp",1)
	addP("aSpeed",1)
	addP("bSpeed",1)
	setP("SynthDef","adder")
	changeMotionModel("Physics")	
	while true do
		local pos = getP("pos")
		local size = getWorldSize()
		setP("aSpeed",pos:x() / size:x() )
		setP("bSpeed",pos:y() / size:y() )
		coroutine.yield()
	end	

end


function ai_AddSpawn()
	initai()
	addP("spawn",1)
	addP("childVel",Vec2.new(0,0))
	local id = getID()
	while true do		
		local spawn = getP("spawn")
		while spawn > 0 do
			local child = spawnRelative(id,1,"ai_Adder",0,0)	
			setPID("Velocity",getPID("childVel",id),childid)	
			spawn = spawn -1		
		end
		setP("spawn",0)	
		coroutine.yield()	
	end		
end


function ai_GestureA()
	initai()
	addP("run",1)
	addP("childSpeed",30)
	addP("pause",4)
	--print("gesture A props done")
	coroutine.yield()
	--print("gesture A enter run loop")
	while getP("run") > 0 do
		local id = getID()
		local speed = getP("childSpeed")
		local child = spawnRelative(id,1,"ai_Adder",-100,-100)	
		setPID("Velocity",Vec2.new(speed,speed),child)	
		local child = spawnRelative(id,1,"ai_Adder",100,100)	
		setPID("Velocity",Vec2.new(speed *-1,speed*-1),child)	
		local child = spawnRelative(id,1,"ai_Adder",100,-100)	
		setPID("Velocity",Vec2.new(speed*-1,speed),child)	
		local child = spawnRelative(id,1,"ai_Adder",-100,100)	
		setPID("Velocity",Vec2.new(speed,speed*-1),child)	
		pause(getP("pause"))
		killChildren()	
	end
	die()
end


function ai_ConstantCanopy()
	initai()
	local props = {run = 1,spawnrate=0.2,childBuffer=0,childVel = Vec2.new(20,0),grainsize=1,childAmp = 0.2}
	setP(props)
	changeMotionModel("Physics")
	local id = getID()
	while getP("run") > 0 do
		local childid = spawnRelative(id,1,"ai_BasicBubble",(math.random()* 5) - 5*0.5, 		(math.random()* 5) - 5 *0.5 )
		local args = {bufNum= getPID("childBuffer",id),Velocity = getPID("childVel",id),amp =getPID("childAmp",id),dur = getPID("grainsize",id)  }
    	--	setPID("bufNum",getPID("childBuffer",id),childid)
    	--	setPID("Velocity", getPID("childVel",id)  ,childid)
    	--	setPID("amp",getPID("childAmp",id),childid)   
	--	setPID("dur", getPID("grainsize",id),childid)
		setPID(args,childid)
    		pause(getPID("spawnrate",id))
	end
	
	die()
end

function ai_Splitter()
	initai()
	local baseprops = {Velocity = Vec2.new(20,0),run = 1,spawnrate = 0.1,buffer = 0,childVel = Vec2.new(10,0),grainsize = 1,childAmp = 0.3,splitRate = 2.5}
	setP(baseprops)
	changeMotionModel("Physics")

	local count = 0
	local id = getID()
	while getP("run") >0 do 	
--spawning of basic grains
		local args = {bufNum= getPID("buffer",id),amp =getPID("childAmp",id),dur = getPID("grainsize",id)  }
		local childid = spawnRelative(args,id,1,"ai_BasicBubble",(math.random()* 5) - 5,0 )		
		setPID(args,childid)		
--detect whether to split		
		if count >= getP("splitRate") then
			childid  = spawnRelativeP(baseprops,id,1,"ai_Splitter",0,0)			
			waitforchild()			
			setPID("Velocity",Vec2.new(20,  ((math.random()*2) -1 ) * math.random()*15    ) ,childid)
			setP("splitRate",10000)
		end	
		count = count + getP("spawnrate")
		pause(getP("spawnrate"))
	end
	die()
end

function ai_VelTest()
	initai()
	spawnP({Velocity = Vec2.new(400,400)},getID(),1,"ai_ConstantCanopy",100,100)
	pause(30)
	die()
end

function cluster(id,pos)
	local args = {Velocity = Vec2.new(100,100)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
	args = {Velocity = Vec2.new((math.random()*100)-50,(math.random()*100)-50)}
	child = spawnP(args,id,1,"ai_ConstantCanopy",pos:x(),pos:y())
end

function ai_SequenceA()
	initai()
	print("Sequence A")

	local id = getID()	
	local args = {Velocity= Vec2.new(30,4 * math.random())}	
	local child = spawnP(args,id,1,"ai_ConstantCanopy",600,800)
	child = spawnP(args,id,1,"ai_ConstantCanopy",600,600)
	child = spawnP(args,id,1,"ai_ConstantCanopy",600,700)
	pause(15)
	args = {pos = Vec2.new(100,300) }
	local Splitterchild = spawnP(args,id,1,"ai_Splitter",100,300)
	pause(25)	
	-- prepare arguement 1 
	args = {pause = 2.5,childSpeed = 40}
	local child = spawnP(args,id,1,"ai_GestureA",600,400)
	waitforchild()
	setPID(args,child)
	pause(2.5)
	cluster(id,Vec2.new(600,400))
	cluster(id,Vec2.new(600,800))
	setPID("run",0,child)
	setPID("run",0,Splitterchild)
	local id = getID()
	args = {Velocity= Vec2.new(30,4)}	
	child = spawnP(args,id,1,"ai_ConstantCanopy",600,800)
	child = spawnP(args,id,1,"ai_ConstantCanopy",600,600)
	child = spawnP(args,id,1,"ai_ConstantCanopy",600,700)
	
	pause(20)
	args = {childSpeed = 5,pause = 20}
	for i = 1, 5, 1 do
		local id = getID()	
		local child = spawn(id,1,"ai_GestureA",800   ,700 - (i* 80  ))
		waitforchild()
		setPID(args,child)
	end
	pause(20)
	killChildren()
	cluster(id,Vec2.new(600,500))


	waitforchild()		
--	setPID{args,child}
--	setPID{"Velocity",Vec2.new(100,100),child}
--	child = spawn(id,1,"ai_VelTest",300,300)
	
	pause(60)
	die()
end

function ai_Grain()
	initai()
	local world = getWorldSize()
	local pos = getP("pos")
	local args = {startpos = pos:x()/world:x(),speed = pos:y()/world:y() * 1.5 ,amp = 1,dur = 1,bufNum = 0,pan = (math.random()*2.0)-1.0,sendAmout = 1,sendBus = 18}
	changeMotionModel("Physics")
	initP(args)
	setP("SynthDef","grain")		
	pause(getP("dur")+1)
	die()
end


function ai_MANGLER()
	initai()
	local args = {range = 9,offset = 0,childdur = 0.2,rate = 0.01,x = 50,y = 50,amp = 0.1,rrate =  0.4}
	initP(args)
	local id = getID()
	changeMotionModel("Physics")
	while true do
		local args = {dur = getP("childdur"),amp = getP("amp"),bufNum = math.random()* getP("range") + getP("offset")}	
		local x = getP("x")
		local y = getP("y")			
		local child = spawnRelativeP(args,id,1,"ai_Grain",(math.random()* x)- x*0.5,(math.random()* y)- y*0.5 )
		waitforchild()
		setPID(args,child)
		pause(getP("rate")  )	
	end
	print("exited loop")
end



--rate and child duration depicted by x and y positions
function ai_Granulator()
	initai()
	local args = {childdur = 0.2,rate = 0.2,x = 50,y = 50,amp = 0.1,rrate =  0.4,buffer = 0,speed = 1, playpos = 0}
	initP(args)
	local id = getID()
	changeMotionModel("Physics")
	while true do
		local pos = getP("pos")		
		local world = getWorldSize()	
		local args = {dur = (pos:x()/world:x() ) , amp = getP("amp"),bufNum = getP("buffer"),speed = getP("speed"),startpos = getP("playpos")}	
		local x = getP("x")
		local y = getP("y")	
		--print("grain spawned ")		
		local child = spawnRelativeP(args,id,1,"ai_Grain",(math.random()* x)- x*0.5,(math.random()* y)- y*0.5 )
		waitforchild()
		setPID(args,child)
		pause( (pos:y()/world:y())*0.1   )	
	end
	print("exited loop")

end


function ai_DelayController()
	initai()
	local args = {maxDel = 2,delay  = 0.2,decay = 1,amp = 0.5,out = 0,control = 1}
	addP(args)
	local id = getID()
	changeMotionModel("Physics")
	setP("SynthDef","delayController")
	while true do 
		if getP("control") > 0 then
			local world = getWorldSize()
			local pos = getP("pos")			
			setP({ delay = pos:x()/world:x()* 0.5 , amp = pos:y()/world:y()    })			
		end			
		coroutine.yield()
	end
end


function ai_ReverbController()
	initai()
	local args = {mix = 0.9,room  = 0.5,damp = 0.5,amp = 0.9,out = 0,control = 0}
	addP(args)
	local id = getID()
	changeMotionModel("Physics")
	setP("SynthDef","reverbController")
	while true do 
		if getP("control") > 0 then
			local world = getWorldSize()
			local pos = getP("pos")			
			setP({ room = pos:x()/world:x()* 0.5 , damp = pos:y()/world:y()    })			
		end			
		coroutine.yield()
	end
end



function ai_Player()
	initai()
	local args = {pitch = 261.625,amp = 1,dur = 1,pan = 0,SynthDef = "player",bufNum = 3}
	setP(args)
	pause(getP("dur"))		
	die()
end

function ai_PlayerTracker()
	initai()
	local args = {pitch = 261.625,amp = 1,dur = 10,pan = 0,SynthDef = "player",bufNum = 3}
	setP(args)
	local remain = getP("dur") 
	while remain > 0 do 
		local dt = getDT()
		remain = remain - dt
		setP("pitch", getP("pos"):y())
		yield()	
	end
	
	pause(0.2)	
	die()
end

function ai_GlissGen()
	initai()
	local args  = {noChildren = 5, vRange = 100,panRange = 1,harm = 2,spawnRate = 5, childDur = 5,speedRange = 200,childBuff = 3 }
	addP(args)
	local id = getID()
	while true do	
		local y = getP("pos"):y()
		for i = 1, getP("noChildren"),1 do 		
			local panRange = getP("panRange")
			local vel =  Vec2.new( 30,  (math.random() * getP("speedRange"))- getP("speedRange")    )   
			local childArgs = {dur = getP("childDur"), pan =  0,Velocity = vel ,bufNum = getP("childBuff") }	
			local v = (getP("vRange")* math.random())		
			local childId = spawnRelativeP(childArgs,id,1,"ai_PlayerTracker",0,v)						
			waitforchild()			
			setPID(childArgs,childId)
		end
		pause(getP("spawnRate"))	
	end
	die()
end

