function spherepath(index,step,x,y)
	removePath(index)
	for i = 1,step,1 do
		addPathPoint(index, math.sin((i/step)*(math.pi * 2.0)   ) * 50,math.cos((i/step)*(math.pi*2.0) ) * 50  )
	end
	movePath(index,x,y)
end

function sinpath( index,step,x,y)
	removePath(index)
	for i = 1,step,1 do
		addPathPoint(index, i * 4,math.cos((i/step)*(math.pi*2.0) ) * 100  )
	end
	movePath(index,x,y) 
end


function gridpath( index,step,x,y,width,height)
	removePath(index)
	for r = 1,step,1 do
		for c = 1 ,step,1 do
			addPathPoint(index,(r/step)*width,(c/step)*height)
		end
	end
	movePath(index,x,y) 
end

function cubepath(index,x,y,width,height)
	removePath(index)
	local hw = width/2.0
	local hh = height/2.0
	addPathPoint(index,- hw,  - hh)
	addPathPoint(index, hw,  - hh)
	addPathPoint(index, hw,   hh)
	addPathPoint(index,- hw,   hh)
	addPathPoint(index,- hw,  - hh)
	movePath(index,x,y) 

end


function ai_GeneratePaths()
	initai()
	local pos = getP("pos")
	spherepath(0,20,pos:x(),pos:y())
	sinpath(1,50,pos:x(),pos:y())
	gridpath(2,4,pos:x(),pos:y(),100,100)
	cubepath(3,400,400,20,20)
	pause(1)
	die()
end